//+------------------------------------------------------------------+
//|                                           ind_Zakruglenie_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 White
#property indicator_color2 Violet
#property indicator_color3 DeepSkyBlue
#property indicator_color4 Violet
#property indicator_color5 DeepSkyBlue
//---- input parameters
extern int       ExtParam1;
//---- buffers
double val[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,val);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,ExtMapBuffer5);
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               val[i]=iStochastic(NULL,0,5,5,3,0,0,1,i);
               ExtMapBuffer2[i]=EMPTY_VALUE;
               ExtMapBuffer3[i]=EMPTY_VALUE; 
               ExtMapBuffer4[i]=EMPTY_VALUE;
               ExtMapBuffer5[i]=EMPTY_VALUE;                
               
                             
               double s0=val[i]-val[i+1];
               double s1=val[i+1]-val[i+2];
               double s2=val[i+2]-val[i+3];
                  
               double u0=s0-s1;
               double u1=s1-s2;
               
                  if(s0>0 && s1>0 && s2>0){
                     if(u0<0){
                        ExtMapBuffer2[i]=val[i];
                        ExtMapBuffer4[i]=val[i];                        
                        
                     }
                  }
                  if(s0<0 && s1<0 && s2<0){
                     if(u0>0){
                        ExtMapBuffer3[i]=val[i]; 
                        ExtMapBuffer5[i]=val[i];                         
                                            
                     }
                  }                     
                                       
               
            }

   return(0);
}

